#ifndef BACKGROUNDWIDGET_H
#define BACKGROUNDWIDGET_H

#include "dm_common_global.h"

#include <QWidget>
#include <QPaintEvent>


class DM_COMMONSHARED_EXPORT BackgroundWidget : public QWidget
{
    Q_OBJECT

public:
    explicit BackgroundWidget(QWidget *parent = nullptr);
    ~BackgroundWidget() override;

public:
    void setImage(const QPixmap& pixmap);
    void setKeepProportions(const bool keep);
    void setLogo(const QPixmap& pixmap);
    void setColor(const QColor& color);
    void setBlurRadius(const double radius);

protected:
    void paintEvent(QPaintEvent* event) override;
    void resizeEvent(QResizeEvent* event) override;

private:
    void updateCachedImage();

private:
    QPixmap m_imagePixmap;
    bool m_keepProportions;
    QPixmap m_logoPixmap;
    QColor m_color;
    double m_blurRadius;
    QImage m_cachedImage;
};

#endif // BACKGROUNDWIDGET_H
